package io.accumulatenetwork.sdk.generated.query;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Account;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("DirectoryQueryResult")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class DirectoryQueryResult implements Marshallable {
	private String[] entries;
	private Account[] expandedEntries;
	private long total;

    //
	public String[] getEntries() {
	    return entries;
	}
	public void setEntries(final String[] value) {
	    this.entries = value;
	}

	public DirectoryQueryResult entries(final String[] value) {
	    setEntries(value);
	    return this;
	}
	public Account[] getExpandedEntries() {
	    return expandedEntries;
	}
	public void setExpandedEntries(final Account[] value) {
	    this.expandedEntries = value;
	}

	public DirectoryQueryResult expandedEntries(final Account[] value) {
	    setExpandedEntries(value);
	    return this;
	}
	public long getTotal() {
	    return total;
	}
	public void setTotal(final long value) {
	    this.total = value;
	}

	public DirectoryQueryResult total(final long value) {
	    setTotal(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.entries == null || this.entries.length == 0)) {
            marshaller.writeString(1, this.entries);
        }
        if (!(this.expandedEntries == null)) {
            marshaller.writeValue(2, expandedEntries);
        }
        marshaller.writeUint(3, this.total);
        return marshaller.array();
    }
}
